/*
 * Copyright (c) 1998, 1999, Bjorn Lindgren <bjorn@500mhz.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by
 *      Bjorn Lindgren <bjorn@500mhz.net>.
 * 4. Neither the name of the authors nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

static const char rcsid[] = "$Id$";

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif /* HAVE_CONFIG_H */

#include <xwhois.h>

__BEGIN_DECLS

char *getsrvbyobj __P((char *));
char *getobjbysrv __P((char *));
int getsrvpos __P((char *));
int getsrvnum __P((void));

__END_DECLS

char *
getsrvbyobj(obj)
     char *obj;
{
  int i;

  for (i=0 ; he[i].object != NULL ; i++)
    {
      if (!strcmp(obj, he[i].object))
	{
	  return he[i].server;
	}
    }

  return NULL;
}

char *
getobjbysrv(srv)
     char *srv;
{
  int i;

  for (i=0 ; he[i].server != NULL ; i++)
    {
      if (!strcmp(srv, he[i].server))
	{
	  return he[i].object;
	}
    }

  return NULL;
}

int
getsrvpos(srv)
     char *srv;
{
  int i;

  for (i=0 ; servers[i].name != NULL ; i++)
    {
      if (!strcmp(srv, servers[i].name))
        {
          return i;
        }
    }

  return 0;
}

int
getsrvnum(void)
{
  int i;

  for (i=0 ; servers[i].name != NULL ; i++);

  return i;
}
